#ifndef WINTERNITZ_H
#define WINTERNITZ_H

#define CRYPTO_OTS_HASHBYTES 32

#define WOTS_LOGW 4
#define WOTS_W    (1<<WOTS_LOGW)                       // 16
#define WOTS_L1   ((CRYPTO_OTS_HASHBYTES*8)/WOTS_LOGW) // 64
#define WOTS_L2   3               
#define WOTS_L    (WOTS_L1+WOTS_L2)                    // 67

#define CRYPTO_OTS_SECRETKEYBYTES (WOTS_L*CRYPTO_OTS_HASHBYTES)
#define CRYPTO_OTS_PUBLICKEYBYTES (CRYPTO_OTS_SECRETKEYBYTES)
#define CRYPTO_OTS_SIGBYTES CRYPTO_OTS_SECRETKEYBYTES

int crypto_ots_keypair(unsigned char *pk, unsigned char *sk) ;

int crypto_ots_sign(unsigned char *sig,
                    const unsigned char *m,
                    unsigned long long mlen, 
                    const unsigned char *sk);

int crypto_ots_verify(unsigned char *pk,
                      const unsigned char *m,
                      unsigned long long mlen,
                      const unsigned char *sig);

#endif
